<copyright> Conditions.
    Written by <a href="mailto:tiggr@ics.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1996, 1997 Pieter J. Schoenmakers.

    This file is part of TOM.  TOM is distributed under the terms of the
    TOM License, a copy of which can be found in the TOM distribution; see
    the file LICENSE.

    <id>$Id: Conditions.t,v 1.20 1998/01/05 01:05:40 tiggr Exp $</id>
    </copyright>

<doc> The {Conditions} class is an instance-less non-static-state-less
    class providing predefined conditions.  Not-predefined, i.e. user
    defined, conditions should be made available to the world through an
    extension of {Conditions}.  </doc>
implementation class
Conditions
{
  <doc> The object informed of unhandled condition raises.  Iff {nil}, the
      program aborts when a condition being raised is not handled.  </doc>
  static All unhandled_condition_handler;

  <doc> The selector of the message to be sent to the
      {unhandled_raise_handler}.  This method accepts a single argument,
      which will be a {Condition}.  </doc>
  static selector unhandled_condition_selector;

  // Should teach gi about indentation like this.
  // Thu May  2 01:36:14 1996, --Tiggr
  <doc> Various (and numerous) condition classes, indented according to
      condition inheritance.  </doc>
  static ConditionClass
    condition,
      warning,
      unimplemented,
      encoding-condition,
      serious-condition,
	runtime-condition,
	  runtime-fatal,
	  nil-receiver,
	  unrecognized-selector,
          uncaught-throw,
        program-condition,
	  unknown-class-condition,
	  coding-condition,
	  type-condition,
	  lock-condition,
	  condition-condition,
        error,
	  file-error,
	  stream-error,
	    stream-eos,
      signal-condition,
        signal-hup,
	signal-int,
	signal-bus,
	signal-segv;
}

<doc> Initialize the condition classes.  </doc>
void
  load MutableArray arguments
{
  /* Get a short name, `c', for the ConditionClass.  */
  class (ConditionClass) c = [ConditionClass self];

  condition = [c with nil name "condition"];
  warning = [c with condition name "warning"];
  unimplemented = [c with condition name "unimplemented"];
  encoding-condition = [c with condition name "encoding-condition"];
  serious-condition = [c with condition name "serious-condition"];
  runtime-condition = [c with serious-condition name "runtime-condition"];
  runtime-fatal = [c with runtime-condition name "runtime-fatal"];
  nil-receiver = [c with runtime-condition name "nil-receiver"];
  unrecognized-selector = [c with runtime-condition
			     name "unrecognized-selector"];
  uncaught-throw = [c with runtime-condition name "uncaught-throw"];
  program-condition = [c with serious-condition name "program-condition"];
  unknown-class-condition = [c with program-condition
			       name "unknown-class-condition"];
  coding-condition = [c with program-condition name "coding-condition"];
  lock-condition = [c with program-condition name "lock-condition"];
  condition-condition = [c with program-condition name "condition-condition"];
  type-condition = [c with program-condition name "type-condition"];
  error = [c with serious-condition name "error"];
  file-error = [c with error name "file-error"];
  stream-error = [c with error name "stream-error"];
  stream-eos = [c with error name "stream-eos"];
  signal-condition = [c with condition name "signal-condition"];
  signal-hup = [c with signal-condition name "signal-hup"];
  signal-int = [c with signal-condition name "signal-int"];
  signal-bus = [c with signal-condition name "signal-bus"];
  signal-segv = [c with signal-condition name "signal-segv"];
}

end;

implementation instance Conditions end;
